<template>
	<div class="menu">
		<component
			v-for="item in items"
			v-on:click="onClick"
			v-on:hover="setSelected"
			:id="item.id"
			:is="item.type"
			:key="item.id"
			:ref="item.ref"
			:selected="item.id === selected"
		>{{ item.text }}</component>
	</div>
</template>

<script>
import * as TOWER from "../../constants/tower.js"

import StandardItem from "../components/StandardItem.vue"

const buildItem = (id, text) => {
	return {
		id: id,
		ref: `r${id}`,
		text,
		type: "standard-item"
	}
}

export default {
	beforeDestroy () {
		UI.off("PRESS_BACK", this.onPressBack)
		UI.off("PRESS_DOWN", this.onPressDown)
		UI.off("PRESS_ENTER", this.onPressEnter)
		UI.off("PRESS_UP", this.onPressUp)
	},
	components: { StandardItem },
	computed: {
		items: function () {
			let items = [
				buildItem(0, Language.get("ONLINE")),
				buildItem(1, Language.get("LOCAL")),
				buildItem(2, "Car Customisation"),
				buildItem(3, Language.get("OPTIONS"))
			]

			if (!IS_XBOX) {
				items.push(buildItem(4, Language.get("QUIT")))
			}

			return items
		}
	},
	created () {
		UI.on("CHANGE_LANGUAGE", () => {
			this.onLanguageChange()
		})
	},
	data () {
		return {
			mounted: false,
			selected: 0
		}
	},
	destroyed () {
		this.mounted = false
	},
	methods: {
		onClick: function (id) {
			UI.emit("PLAY_CLICK_SOUND")
			if (id !== null && id !== undefined) {
				UI.emit("SELECT_MAIN_MENU", id)
			} else {
				this.$refs["r0"][0].onClick()
			}
		},
		onLanguageChange: function () {
			this.items[0].text = Language.get("ONLINE")
			this.items[1].text = Language.get("LOCAL")
			this.items[3].text = Language.get("OPTIONS")
			if (!IS_XBOX) this.items[4].text = Language.get("QUIT")
		},
		onPressBack: function () {
			StateManager.change(States.PressStart)
		},
		onPressDown: function () {
			this.setSelected(Math.min(this.items.length - 1, this.selected + 1))
		},
		onPressEnter: function () {
			this.onClick(this.selected)
		},
		onPressUp: function () {
			this.setSelected(Math.max(0, this.selected - 1))
		},
		setSelected: function (id) {
			const ref = this.items[this.selected].ref
			if (!this.$refs[ref][0].focused && this.selected !== id) {
				UI.emit("PLAY_HOVER_SOUND")
				this.selected = id
			}
		}
	},
	mounted () {
		this.mounted = true

		// Update tower
		Tower.goToRooftop()
		Tower.setState(TOWER.STATE_SCENIC_ROOFTOP)

		// Events
		UI.on("PRESS_BACK", this.onPressBack)
		UI.on("PRESS_DOWN", this.onPressDown)
		UI.on("PRESS_ENTER", this.onPressEnter)
		UI.on("PRESS_UP", this.onPressUp)
	},
	name: "main-menu"
}
</script>

<style lang="less" scoped>
@import "./styles/Menu.less";

.menu {
	height: 62em;
	width: 50em;
}

.logo {
	height: 16em;
	left: 0;
	position: absolute;
	top: 0;
}
</style>